package com.shafaat.apps.mouse.mover;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.springframework.boot.test.context.SpringBootTest;

import java.security.SecureRandom;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Random;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

//@SpringBootTest
class MouseMoverApplicationTests {

    @Test
    void contextLoads() {
        List<String> email = Arrays.asList("Email");
        System.out.println(email);
        Assertions.assertTrue(email.size() == 1);
    }

    @Test
     void randomPassword(){
        String specials = "!@#$_";
        String alphaSmall = "abcdefghijklmnopqrstuvwxyz";
        String numbers = "0123456789";
        Random rnd = new Random();
        StringBuilder sb = new StringBuilder(8);

        sb.append(specials.charAt(rnd.nextInt(specials.length())));
        sb.append(numbers.charAt(rnd.nextInt(numbers.length())));
        sb.append(String.valueOf(alphaSmall.charAt(rnd.nextInt(alphaSmall.length()))).toUpperCase());

        for (int i = 0; i < 5; i++)
            sb.append(alphaSmall.charAt(rnd.nextInt(alphaSmall.length())));

        System.out.println(sb.toString());

        IntStream intStreams = sb.toString().chars();
        Stream<Character> characterStream = intStreams.mapToObj(data -> (char) data);

        List<Character> charList = characterStream.collect(Collectors.toList());

        Collections.shuffle(charList);

        String password = charList.stream()
                .collect(StringBuilder::new, StringBuilder::append, StringBuilder::append)
                .toString();

        System.out.println(password);

        Assertions.assertTrue(password.length() == 8);

    }

}
