package com.shafaat.apps.mouse.mover.controller;

import com.shafaat.apps.mouse.mover.service.ConfigService;
import com.shafaat.apps.mouse.mover.service.MouseMoverService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/api/mouse")
public class MouseController {

    @Autowired
    private MouseMoverService mouseMoverService;

    @Autowired
    private ConfigService configService;


    @GetMapping("/start")
    public String move(){

        Thread newThread = new Thread(() -> {
            mouseMoverService.moveMouse();
        });
        newThread.start();
        configService.setRunningFlag(Boolean.TRUE);

        return "success";
    }

    @GetMapping("/stop")
    public String stop(){
        configService.setStopFlag(Boolean.TRUE);
        configService.setRunningFlag(Boolean.FALSE);
        return "Requested to stop";
    }


}
